Index: /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90
===================================================================
--- /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 5202)
@@ -772,13 +826,13 @@
     END DO
   ELSE
-    iq = 1
+    lerr = getKey('gen0Name',   gen0N, tr%keys); IF(lerr) RETURN     !--- Names of the tracers    iq = 1
     DO jq = 1, nq                                                    !--- Loop on generation 0 tracers
-      IF(tr(jq)%iGeneration /= 0) CYCLE                              !--- Skip generations /= 0
+      IF(iGen(jq) /= 0) CYCLE                                        !--- Skip generations /= 0
       ix(iq) = jq                                                    !--- Generation 0 ancestor index first
       iq = iq + 1                                                    !--- Next "iq" for next generations tracers
-      iy = strFind(tr(:)%gen0Name, TRIM(tr(jq)%name))                !--- Indexes of "tr(jq)" children in "tr(:)"
-      ng = MAXVAL(tr(iy)%iGeneration, MASK=.TRUE., DIM=1)            !--- Number of generations of the "tr(jq)" family
+      iy = strFind(gen0N(:), TRIM(tname(jq)))                        !--- Indices of "tr(jq)" children in "tr(:)"
+      ng = MAXVAL(iGen(iy), MASK=.TRUE., DIM=1)                      !--- Number of generations of the "tr(jq)" family
       DO ig = 1, ng                                                  !--- Loop   on generations of the "tr(jq)" family
-        iz = find(tr(iy)%iGeneration, ig, n)                         !--- Indexes of the tracers "tr(iy(:))" of generation "ig"
+        iz = find(iGen(iy), ig, n)                                   !--- Indices of the tracers "tr(iy(:))" of generation "ig"
         ix(iq:iq+n-1) = iy(iz)                                       !--- Same indexes in "tr(:)"
         iq = iq + n
@@ -796,10 +850,14 @@
   TYPE(trac_type), ALLOCATABLE, INTENT(OUT) ::       tr(:)
   TYPE(trac_type), POINTER ::   t1(:),   t2(:)
+  TYPE(keys_type), POINTER ::   k1(:),   k2(:)
   INTEGER,     ALLOCATABLE :: ixct(:), ixck(:)
-  INTEGER :: is, k1, k2, nk2, i1, i2, nt2
+  INTEGER :: is, ik, ik1, ik2, nk2, i1, i2, nt2
   CHARACTER(LEN=maxlen) :: s1, v1, v2, tnam, knam, modname
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: keys(:), n1(:), n2(:)
   modname = 'mergeTracers'
   lerr = .FALSE.
-  t1 => sections(1)%trac(:)                                          !--- Alias: first tracers section
+  keys = ['parent     ', 'type       ', 'iGeneration']               !--- Mandatory keys
+  t1 => sections(1)%trac(:); k1 => t1(:)%keys                        !--- Alias: first tracers section, corresponding keys
+  lerr = getKey('name', n1, k1); IF(lerr) RETURN                     !--- Names of the tracers
   tr = t1
   !----------------------------------------------------------------------------------------------------------------------------
@@ -807,10 +865,12 @@
   !----------------------------------------------------------------------------------------------------------------------------
     t2  => sections(is)%trac(:)                                      !--- Alias: current tracers section
+    k2  => t2(:)%keys
+    lerr = getKey('name', n2, k2); IF(lerr) RETURN                   !--- Names of the tracers
     nt2  = SIZE(t2(:), DIM=1)                                        !--- Number of tracers in section
-    ixct = strIdx(t1(:)%name, t2(:)%name)                            !--- Indexes of common tracers
+    ixct = strIdx(n1(:), n2(:))                                      !--- Indexes of common tracers
     tr = [tr, PACK(t2, MASK= ixct==0)]                               !--- Append with new tracers
     IF( ALL(ixct == 0) ) CYCLE                                       !--- No common tracers => done
     CALL msg('Tracers defined in previous sections and duplicated in "'//TRIM(sections(is)%name)//'":', modname)
-    CALL msg(t1(PACK(ixct, MASK = ixct/=0))%name, modname, nmax=128) !--- Display duplicates (the 128 first at most)
+    CALL msg(n1(PACK(ixct, MASK = ixct/=0)), modname, nmax=128)      !--- Display duplicates (the 128 first at most)
     !--------------------------------------------------------------------------------------------------------------------------
     DO i2=1,nt2; tnam = TRIM(t2(i2)%name)                            !=== LOOP ON COMMON TRACERS
@@ -820,34 +880,35 @@
       !=== CHECK WETHER ESSENTIAL KEYS ARE IDENTICAL OR NOT
       s1=' of "'//TRIM(tnam)//'" in "'//TRIM(sections(is)%name)//'" not matching previous value'
-      
-      IF(test(fmsg('Parent name'//TRIM(s1), modname, t1(i1)%parent      /= t2(i2)%parent),      lerr)) RETURN
-      IF(test(fmsg('Type'       //TRIM(s1), modname, t1(i1)%type        /= t2(i2)%type),        lerr)) RETURN
-      IF(test(fmsg('Generation' //TRIM(s1), modname, t1(i1)%iGeneration /= t2(i2)%iGeneration), lerr)) RETURN
-
-      !=== APPEND <key>=<val> PAIRS NOT PREVIOULSLY DEFINED
-      nk2  = SIZE(t2(i2)%keys%key(:))                                !--- Keys number in current section
-      ixck = strIdx(t1(i1)%keys%key(:), t2(i2)%keys%key(:))          !--- Common keys indexes
-
-      !=== APPEND NEW KEYS
+      DO ik = 1, SIZE(keys)
+        lerr = getKey(keys(ik), v1, i1, k1)
+        lerr = getKey(keys(ik), v2, i2, k2)
+        lerr = v1 /= v2; IF(fmsg(TRIM(keys(ik))//TRIM(s1), modname, lerr)) RETURN
+      END DO
+
+      !=== GET THE INDICES IN tr(i2)%keys%key(:) OF THE KEYS ALSO PRESENT IN tr(i1)%keys%key(:)
+      nk2  =   SIZE(k2(i2)%key(:))                                   !--- Keys number in current section
+      ixck = strIdx(k1(i1)%key(:), k2(i2)%key(:))                    !--- Common keys indexes
+      !--- APPEND THE NEW KEYS PAIRS IN tr(i1)%keys%key(:)
       tr(i1)%keys%key = [ tr(i1)%keys%key, PACK(tr(i2)%keys%key, MASK = ixck==0)]
       tr(i1)%keys%val = [ tr(i1)%keys%val, PACK(tr(i2)%keys%val, MASK = ixck==0)]
 
-      !--- KEEP TRACK OF THE COMPONENTS NAMES
-      tr(i1)%component = TRIM(tr(i1)%component)//','//TRIM(tr(i2)%component)
-
-      !--- SELECT COMMON TRACERS WITH DIFFERING KEYS VALUES (PREVIOUS VALUE IS KEPT)
-      DO k2=1,nk2
-        k1 = ixck(k2); IF(k1 == 0) CYCLE
-        IF(t1(i1)%keys%val(k1) == t2(i2)%keys%val(k2)) ixck(k2)=0
+      !=== KEEP TRACK OF THE COMPONENTS NAMES: COMA-SEPARATED LIST
+      lerr = getKey('component', v1, i1, k1)
+      lerr = getKey('component', v2, i2, k2)
+      tr(i1)%component = TRIM(v1)//','//TRIM(v2)
+      CALL addKey('component', TRIM(v1)//','//TRIM(v2), tr(i1)%keys)
+
+      !=== FOR TRACERS COMMON TO PREVIOUS AND CURRENT SECTIONS: CHECK WETHER SOME KEYS HAVE DIFFERENT VALUES ; KEEP OLD ONE
+      DO ik2 = 1, nk2                                                !--- Collect the corresponding indices
+        ik1 = ixck(ik2); IF(ik1 == 0) CYCLE
+        IF(k1(i1)%val(ik1) == k2(i2)%val(ik2)) ixck(ik2)=0
       END DO
-      IF(ALL(ixck==0)) CYCLE                                         !--- No identical keys with /=values
-
-      !--- DISPLAY INFORMATION: OLD VALUES ARE KEPT FOR THE KEYS FOUND IN PREVIOUS AND CURRENT SECTIONS
-      CALL msg('Key(s)'//TRIM(s1), modname)
-      DO k2 = 1, nk2                                                 !--- Loop on keys found in both t1(:) and t2(:)
-        knam = t2(i2)%keys%key(k2)                                   !--- Name of the current key
-        k1 = ixck(k2)                                                !--- Corresponding index in t1(:)
-        IF(k1 == 0) CYCLE                                            !--- New keys are skipped
-        v1 = t1(i1)%keys%val(k1); v2 = t2(i2)%keys%val(k2)           !--- Key values in t1(:) and t2(:)
+      IF(ALL(ixck==0)) CYCLE                                         !--- No identical keys with /=values => nothing to display
+      CALL msg('Key(s)'//TRIM(s1), modname)                          !--- Display the  keys with /=values (names list)
+      DO ik2 = 1, nk2                                                !--- Loop on keys found in both t1(:) and t2(:)
+        knam = k2(i2)%key(ik2)                                       !--- Name of the current key
+        ik1 = ixck(ik2)                                              !--- Corresponding index in t1(:)
+        IF(ik1 == 0) CYCLE                                           !--- New keys are skipped
+        v1 = k1(i1)%val(ik1); v2 = k2(i2)%val(ik2)                   !--- Key values in t1(:) and t2(:)
         CALL msg(' * '//TRIM(knam)//'='//TRIM(v2)//' ; previous value kept:'//TRIM(v1), modname)
       END DO
@@ -862,29 +923,29 @@
 
 !==============================================================================================================================
-LOGICAL FUNCTION cumulTracers(sections, tr) RESULT(lerr)
+LOGICAL FUNCTION cumulTracers(sections, tr, lRename) RESULT(lerr)
   TYPE(dataBase_type),  TARGET, INTENT(IN)  :: sections(:)
   TYPE(trac_type), ALLOCATABLE, INTENT(OUT) ::       tr(:)
-  TYPE(trac_type), POINTER     :: t(:)
-  INTEGER,   ALLOCATABLE :: nt(:)
-  CHARACTER(LEN=maxlen)  :: tnam, tnam_new
-  INTEGER :: iq, nq, is, ns, nsec
-  lerr = .FALSE.                                                     !--- Can't fail ; kept to match "mergeTracer" interface.
-  nsec =  SIZE(sections)
-  tr = [(      sections(is)%trac(:) , is=1, nsec )]                  !--- Concatenated tracers vector
-  nt = [( SIZE(sections(is)%trac(:)), is=1, nsec )]                  !--- Number of tracers in each section
+  LOGICAL,            OPTIONAL, INTENT(IN)  :: lRename               !--- .TRUE.: add a section suffix to identical names
+  CHARACTER(LEN=maxlen)  :: tnam_new, modname
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:), parent(:), comp(:)
+  INTEGER :: iq, jq, is
+  modname = 'cumulTracers'
+  lerr = .FALSE.
+  tr = [( sections(is)%trac(:), is = 1, SIZE(sections) )]            !--- Concatenated tracers vector
+  IF(PRESENT(lRename)) THEN; IF(lRename) RETURN; END IF              !--- No renaming: finished
+  lerr = getKey('name',     tname, tr%keys); IF(lerr) RETURN         !--- Names
+  lerr = getKey('parent',  parent, tr%keys); IF(lerr) RETURN         !--- Parents
+  lerr = getKey('component', comp, tr%keys); IF(lerr) RETURN         !--- Component name
   !----------------------------------------------------------------------------------------------------------------------------
-  DO is=1, nsec                                                      !=== LOOP ON SECTIONS
+  DO iq = 1, SIZE(tr); IF(COUNT(tname == tname(iq)) == 1) CYCLE      !=== LOOP ON TRACERS
   !----------------------------------------------------------------------------------------------------------------------------
-    t => sections(is)%trac(:)
+    tnam_new = TRIM(tname(iq))//'_'//TRIM(comp(iq))                  !--- Same with section extension
+    CALL addKey('name', tnam_new, tr(iq)%keys)                       !--- Modify tracer name
+    tr(iq)%name = TRIM(tnam_new)                                     !--- Modify tracer name
     !--------------------------------------------------------------------------------------------------------------------------
-    DO iq=1, nt(is)                                                  !=== LOOP ON TRACERS
+    DO jq = 1, SIZE(tr); IF(parent(jq) /= tname(iq)) CYCLE           !=== LOOP ON TRACERS PARENTS
     !--------------------------------------------------------------------------------------------------------------------------
-      tnam = TRIM(t(iq)%name)                                        !--- Original name
-      IF(COUNT(t%name == tnam) == 1) CYCLE                           !--- Current tracer is not duplicated: finished
-      tnam_new = TRIM(tnam)//'_'//TRIM(sections(is)%name)            !--- Same with section extension
-      nq = SUM(nt(1:is-1))                                           !--- Number of tracers in previous sections
-      ns = nt(is)                                                    !--- Number of tracers in the current section
-      tr(iq + nq)%name = TRIM(tnam_new)                              !--- Modify tracer name
-      WHERE(tr(1+nq:ns+nq)%parent==tnam) tr(1+nq:ns+nq)%parent=tnam_new  !--- Modify parent name
+      CALL addKey('parent', tnam_new, tr(jq)%keys)                   !--- Modify tracer name
+      tr(jq)%parent = TRIM(tnam_new)                                 !--- Modify tracer name
     !--------------------------------------------------------------------------------------------------------------------------
     END DO
@@ -896,124 +957,138 @@
 !==============================================================================================================================
 
-!==============================================================================================================================
-SUBROUTINE setDirectKeys(tr)
+
+!==============================================================================================================================
+LOGICAL  FUNCTION  dispTraSection(message, sname, modname) RESULT(lerr)
+  CHARACTER(LEN=*), INTENT(IN) :: message, sname, modname
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: s(:,:), n(:), tmp(:)
+  CHARACTER(LEN=maxlen) :: p
+  INTEGER :: idb, iq, nq
+  idb = strIdx(dBase(:)%name, sname); IF(idb == 0) RETURN
+  nq = SIZE(dBase(idb)%trac)
+  p = ''
+  CALL append(['iq'],     .TRUE. ); IF(lerr) RETURN
+  CALL append(['name'],   .TRUE. ); IF(lerr) RETURN
+  CALL append(['phases','phase '], .FALSE., 'pha'); IF(lerr) RETURN
+  CALL append(['hadv'],   .TRUE. ); IF(lerr) RETURN
+  CALL append(['vadv'],   .TRUE. ); IF(lerr) RETURN
+  CALL append(['parent'], .FALSE.); IF(lerr) RETURN
+  CALL append(['iGen'],   .FALSE.); IF(lerr) RETURN
+  CALL msg(TRIM(message)//':', modname)
+  lerr = dispTable(p, n, s, nColMax=maxTableWidth, nHead=2, sub=modname); IF(lerr) RETURN
+
+CONTAINS
+
+SUBROUTINE append(nam, lMandatory, snam)
+! Test whether key named "nam(:)" is available.
+!  * yes: - get its value for all species in "tmp(:)" and append table "s(:,:)" with it
+!         - append titles list with "nam(1)" (or, if specified, "snam", usually a short name).
+!  * no:  return to calling routine with an error flag if the required key is mandatory
+  CHARACTER(LEN=*),           INTENT(IN) :: nam(:)
+  LOGICAL,                    INTENT(IN) :: lMandatory
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: snam
+  INTEGER :: m
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: n0(:)
+  CHARACTER(LEN=maxlen) :: nm
+  lerr = .FALSE.
+  IF(nam(1) == 'iq') THEN
+    tmp = int2str([(iq, iq=1, nq)])
+  ELSE
+    lerr = getKey(nam, tmp, dBase(idb)%trac(:)%keys, lDisp=lMandatory)
+  END IF
+  IF(lerr) THEN; lerr = lMandatory; RETURN; END IF
+  nm = nam(1); IF(PRESENT(snam)) nm = snam
+  p = TRIM(p)//'s'
+  IF(ALLOCATED(s)) THEN; s = cat(s, tmp); ELSE; ALLOCATE(s(nq,1)); s(:,1) = tmp; END IF
+  IF(ALLOCATED(n)) THEN; m = SIZE(n); ALLOCATE(n0(m+1)); n0(1:m)=n; n0(m+1)=nm; CALL MOVE_ALLOC(FROM=n0, TO=n)
+  ELSE; n=nam(1:1); END IF
+END SUBROUTINE append
+
+END FUNCTION dispTraSection
+!==============================================================================================================================
+
+
+!==============================================================================================================================
+!=== CREATE TRACER(S) ALIAS: SCALAR/VECTOR FROM NAME(S) OR INDICE(S) ==========================================================
+!==============================================================================================================================
+LOGICAL FUNCTION aliasTracer(tname, trac, alias) RESULT(lerr)                  !=== TRACER NAMED "tname" - SCALAR
+  CHARACTER(LEN=*),         INTENT(IN)  :: tname
+  TYPE(trac_type), TARGET,  INTENT(IN)  :: trac(:)
+  TYPE(trac_type), POINTER, INTENT(OUT) :: alias
+  INTEGER :: it
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:)
+  alias => NULL()
+  lerr = getKey('name', tnames, trac(:)%keys)
+  it = strIdx(tnames, tname)
+  lerr = it /= 0; IF(.NOT.lerr) alias => trac(it)
+END FUNCTION aliasTracer
+!==============================================================================================================================
+LOGICAL FUNCTION trSubset_Indx(trac, idx, alias) RESULT(lerr)                  !=== TRACERS WITH INDICES "idx(:)" - VECTOR
+  TYPE(trac_type), ALLOCATABLE, INTENT(IN)  ::  trac(:)
+  INTEGER,                      INTENT(IN)  ::   idx(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) :: alias(:)
+  alias = trac(idx)
+  lerr = indexUpdate(alias)
+END FUNCTION trSubset_Indx
+!------------------------------------------------------------------------------------------------------------------------------
+LOGICAL FUNCTION trSubset_Name(trac, tname, alias) RESULT(lerr)                !=== TRACERS NAMED "tname(:)" - VECTOR
+  TYPE(trac_type), ALLOCATABLE, INTENT(IN)  ::  trac(:)
+  CHARACTER(LEN=*),             INTENT(IN)  :: tname(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) :: alias(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:)
+  lerr = getKey('name', tnames, trac(:)%keys)
+  alias = trac(strIdx(tnames, tname))
+  lerr = indexUpdate(alias)
+END FUNCTION trSubset_Name
+!==============================================================================================================================
+LOGICAL FUNCTION trSubset_gen0Name(trac, gen0Nm, alias) RESULT(lerr)           !=== TRACERS OF COMMON 1st GENERATION ANCESTOR
+  TYPE(trac_type), ALLOCATABLE, INTENT(IN)  :: trac(:)
+  CHARACTER(LEN=*),             INTENT(IN)  :: gen0Nm
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) :: alias(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: gen0N(:)
+  lerr = getKey('gen0Name', gen0N, trac(:)%keys)
+  alias = trac(strFind(delPhase(gen0N), gen0Nm))
+  lerr = indexUpdate(alias)
+END FUNCTION trSubset_gen0Name
+!==============================================================================================================================
+
+
+!==============================================================================================================================
+!=== UPDATE THE INDEXES iqParent, iqDescend AND iGeneration IN THE TRACERS DESCRIPTOR LIST "tr" (USEFULL FOR SUBSETS) =========
+!==============================================================================================================================
+LOGICAL FUNCTION indexUpdate(tr) RESULT(lerr)
   TYPE(trac_type), INTENT(INOUT) :: tr(:)
-
-  !--- Update %iqParent, %iqDescen, %nqDescen, %nqChildren
-  CALL indexUpdate(tr)
-
-  !--- Extract some direct-access keys
-!  DO iq = 1, SIZE(tr)
-!    tr(iq)%keys%<key> = getKey_prv(it, "<key>", tr%keys, <default_value> )
-!  END DO
-END SUBROUTINE setDirectKeys
-!==============================================================================================================================
-
-!==============================================================================================================================
-LOGICAL FUNCTION dispTraSection(message, sname, modname) RESULT(lerr)
-  CHARACTER(LEN=*), INTENT(IN) :: message, sname, modname
-  INTEGER :: idb, iq, nq
-  INTEGER, ALLOCATABLE :: hadv(:), vadv(:)
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: phas(:), prnt(:)
-  TYPE(trac_type), POINTER :: tm(:)
-  lerr = .FALSE.
-  idb = strIdx(dBase(:)%name, sname); IF(idb == 0) RETURN
-  tm => dBase(idb)%trac
-  nq = SIZE(tm)
-  !--- BEWARE ! Can't use the "getKeyByName" functions yet.
-  !             Names must first include the phases for tracers defined on multiple lines.
-  hadv = str2int(fgetKeys('hadv',  tm(:)%keys, '10'))
-  vadv = str2int(fgetKeys('vadv',  tm(:)%keys, '10'))
-  prnt =         fgetKeys('parent',tm(:)%keys,  '' )
-  IF(getKey('phases', phas, ky=tm(:)%keys)) phas = fGetKeys('phase', tm(:)%keys, 'g')
-  CALL msg(TRIM(message)//':', modname)
-  IF(ALL(prnt == 'air')) THEN
-    IF(test(dispTable('iiiss',   ['iq    ','hadv  ','vadv  ','name  ','phase '],                   cat(tm%name,       phas),  &
-                 cat([(iq, iq=1, nq)], hadv, vadv),                 nColMax=maxTableWidth, nHead=2, sub=modname), lerr)) RETURN
-  ELSE IF(ALL(tm%iGeneration == -1)) THEN
-    IF(test(dispTable('iiisss', ['iq    ','hadv  ','vadv  ','name  ','parent','phase '],           cat(tm%name, prnt, phas),  &
-                 cat([(iq, iq=1, nq)], hadv, vadv),                 nColMax=maxTableWidth, nHead=2, sub=modname), lerr)) RETURN
-  ELSE
-    IF(test(dispTable('iiissis', ['iq    ','hadv  ','vadv  ','name  ','parent','igen  ','phase '], cat(tm%name, prnt, phas),  &
-                 cat([(iq, iq=1, nq)], hadv, vadv, tm%iGeneration), nColMax=maxTableWidth, nHead=2, sub=modname), lerr)) RETURN
-  END IF
-END FUNCTION dispTraSection
-!==============================================================================================================================
-
-
-!==============================================================================================================================
-!== CREATE A SCALAR ALIAS OF THE COMPONENT OF THE TRACERS DESCRIPTOR "t" NAMED "tname" ========================================
-!==============================================================================================================================
-FUNCTION aliasTracer(tname, t) RESULT(out)
-  TYPE(trac_type),         POINTER    :: out
-  CHARACTER(LEN=*),        INTENT(IN) :: tname
-  TYPE(trac_type), TARGET, INTENT(IN) :: t(:)
-  INTEGER :: it
-  it = strIdx(t(:)%name, tname)
-  out => NULL(); IF(it /= 0) out => t(it)
-END FUNCTION aliasTracer
-!==============================================================================================================================
-
-
-!==============================================================================================================================
-!=== FROM A LIST OF INDEXES OR NAMES, CREATE A SUBSET OF THE TRACERS DESCRIPTORS LIST "trac" ==================================
-!==============================================================================================================================
-FUNCTION trSubset_Indx(trac,idx) RESULT(out)
-  TYPE(trac_type), ALLOCATABLE             ::  out(:)
-  TYPE(trac_type), ALLOCATABLE, INTENT(IN) :: trac(:)
-  INTEGER,                      INTENT(IN) ::  idx(:)
-  out = trac(idx)
-  CALL indexUpdate(out)
-END FUNCTION trSubset_Indx
-!------------------------------------------------------------------------------------------------------------------------------
-FUNCTION trSubset_Name(trac,nam) RESULT(out)
-  TYPE(trac_type), ALLOCATABLE             ::  out(:)
-  TYPE(trac_type), ALLOCATABLE, INTENT(IN) :: trac(:)
-  CHARACTER(LEN=*),             INTENT(IN) ::  nam(:)
-  out = trac(strIdx(trac(:)%name, nam))
-  CALL indexUpdate(out)
-END FUNCTION trSubset_Name
-!==============================================================================================================================
-
-
-!==============================================================================================================================
-!=== CREATE THE SUBSET OF THE TRACERS DESCRIPTORS LIST "trac" HAVING THE FIRST GENERATION ANCESTOR NAMED "nam" ================
-!==============================================================================================================================
-FUNCTION trSubset_gen0Name(trac,nam) RESULT(out)
-  TYPE(trac_type), ALLOCATABLE             ::  out(:)
-  TYPE(trac_type), ALLOCATABLE, INTENT(IN) :: trac(:)
-  CHARACTER(LEN=*),             INTENT(IN) ::  nam
-  out = trac(strFind(delPhase(trac(:)%gen0Name), nam))
-  CALL indexUpdate(out)
-END FUNCTION trSubset_gen0Name
-!==============================================================================================================================
-
-
-!==============================================================================================================================
-!=== UPDATE THE INDEXES iqParent, iqDescend AND iGeneration IN THE TRACERS DESCRIPTOR LIST "tr" (USEFULL FOR SUBSETS) =========
-!==============================================================================================================================
-SUBROUTINE indexUpdate(tr)
-  TYPE(trac_type), INTENT(INOUT) :: tr(:)
-  INTEGER :: iq, ig, igen, ngen, ix(SIZE(tr))
-  tr(:)%iqParent = strIdx( tr(:)%name, tr(:)%parent )                !--- Parent index
-  DO iq = 1, SIZE(tr); CALL addKey_1('iqParent', int2str(tr(iq)%iqParent), tr(iq)%keys); END DO
-  ngen = MAXVAL(tr(:)%iGeneration, MASK=.TRUE.)
-  DO iq = 1, SIZE(tr)
-    ig = tr(iq)%iGeneration
-    IF(ALLOCATED(tr(iq)%iqDescen)) DEALLOCATE(tr(iq)%iqDescen)
-    ALLOCATE(tr(iq)%iqDescen(0))
-    CALL idxAncestor(tr, ix, ig)                                     !--- Ancestor of generation "ng" for each tr
-    DO igen = ig+1, ngen
-      tr(iq)%iqDescen = [tr(iq)%iqDescen, find(ix==iq .AND. tr%iGeneration==igen)]
-      tr(iq)%nqDescen = SIZE(tr(iq)%iqDescen)
-      IF(igen == ig+1) THEN
-        tr(iq)%nqChildren = tr(iq)%nqDescen
-        CALL addKey_1('nqChildren', int2str(tr(iq)%nqChildren), tr(iq)%keys)
-      END IF
+  INTEGER :: iq, jq, nq, ig, nGen
+  INTEGER,               ALLOCATABLE :: iqDescen(:), ix(:), iy(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:), parent(:)
+  INTEGER,       DIMENSION(SIZE(tr)) :: iqParent, iGen
+  lerr = getKey('name',   tnames, tr%keys); IF(lerr) RETURN          !--- Names
+  lerr = getKey('parent', parent, tr%keys); IF(lerr) RETURN          !--- Parents
+  nq = SIZE(tr)
+
+  !=== iqParent, iGeneration
+  DO iq = 1, nq; iGen(iq) = 0; jq = iq
+    iqParent(iq) = strIdx(tnames, parent(iq))
+    DO; jq = strIdx(tnames, parent(jq)); IF(jq == 0) EXIT; iGen(iq) = iGen(iq) + 1; END DO
+    CALL addKey('iqParent',   parent(iq), tr(iq)%keys)
+    CALL addKey('iqGeneration', iGen(iq), tr(iq)%keys)
+  END DO
+
+  !=== nqChildren, iqDescen, nqDescen
+  nGen = MAXVAL(iGen, MASK=.TRUE.)
+  DO iq = 1, nq
+    ix = [iq]; ALLOCATE(iqDescen(0))
+    DO ig = iGen(iq)+1, nGen
+      iy = find(iqParent, ix); iqDescen = [iqDescen, iy]; ix = iy
+      IF(ig /= iGen(iq)+1) CYCLE
+      CALL addKey('nqChildren', SIZE(iqDescen), tr(iq)%keys)
+      tr(iq)%nqChildren = SIZE(iqDescen)
     END DO
-    CALL addKey_1('iqDescen', strStack(int2str(tr(iq)%iqDescen)), tr(iq)%keys)
-    CALL addKey_1('nqDescen',          int2str(tr(iq)%nqDescen) , tr(iq)%keys)
+    CALL addKey('iqDescen', strStack(int2str(iqDescen)), tr(iq)%keys)
+    CALL addKey('nqDescen',             SIZE(iqDescen),  tr(iq)%keys)
+    tr(iq)%iqDescen =      iqDescen
+    tr(iq)%nqDescen = SIZE(iqDescen)
+    DEALLOCATE(iqDescen)
   END DO
-END SUBROUTINE indexUpdate
+END FUNCTION indexUpdate
 !==============================================================================================================================
   
@@ -1024,5 +1099,5 @@
 !===  * For each isotopes class, the <key>=<val> vector of each tracer is moved into the isotopes descriptor "isot"        ====
 !=== NOTES:                                                                                                                ====
-!===  * Most of the "isot" components have been defined in the calling routine (readIsotopes):                             ====
+!===  * Most of the "isot" components have been defined in the calling routine (processIsotopes):                          ====
 !===      parent,  nzone, zone(:),  niso, keys(:)%name,  ntiso, trac(:),  nphas, phas,  iqIsoPha(:,:),  itZonPhi(:,:)      ====
 !===  * Same syntax for isotopes file and "tracer.def": a tracers section contains one line for each of its isotopes       ====
@@ -1032,5 +1107,5 @@
 !===  * The routine gives an error if a required isotope is not available in the database stored in "fnam"                 ====
 !==============================================================================================================================
-LOGICAL FUNCTION readIsotopesFile_prv(fnam, isot) RESULT(lerr)
+LOGICAL FUNCTION readIsotopesFile(fnam, isot) RESULT(lerr)
   CHARACTER(LEN=*),        INTENT(IN)    :: fnam                     !--- Input file name
   TYPE(isot_type), TARGET, INTENT(INOUT) :: isot(:)                  !--- Isotopes descriptors (field %parent must be defined!)
@@ -1049,5 +1124,5 @@
   !--- READ THE FILE SECTIONS, ONE EACH PARENT TRACER
   nb0 = SIZE(dBase, DIM=1)+1                                         !--- Next database element index
-  IF(test(readSections(fnam,strStack(isot(:)%parent,'|')),lerr)) RETURN !--- Read sections, one each parent tracer
+  lerr = readSections(fnam,strStack(isot(:)%parent,'|')); IF(lerr) RETURN !--- Read sections, one each parent tracer
   ndb = SIZE(dBase, DIM=1)                                           !--- Current database size
   DO idb = nb0, ndb
@@ -1067,5 +1142,5 @@
       is = strIdx(isot(iis)%keys(:)%name, t%name)                    !--- Index in "isot(iis)%keys(:)%name" of isotope "t%name"
       IF(is == 0) CYCLE
-      IF(test(ANY(reduceExpr(t%keys%val, vals)), lerr)) RETURN       !--- Reduce expressions ; detect non-numerical elements
+      lerr = ANY(reduceExpr(t%keys%val, vals)); IF(lerr) RETURN      !--- Reduce expressions ; detect non-numerical elements
       isot(iis)%keys(is)%key = t%keys%key
       isot(iis)%keys(is)%val = vals
@@ -1073,6 +1148,7 @@
 
     !--- CHECK FOR MISSING ISOTOPES (NO KEYS ALLOCATED)
-    IF(test(checkList(isot(iis)%keys(:)%name, .NOT.[( ALLOCATED(isot(iis)%keys(is)%key), is=1, SIZE(isot(iis)%keys) )], &
-      'Check file "'//TRIM(fnam)//'" in section "'//TRIM(dBase(idb)%name)//'"', 'isotopes', 'missing'), lerr)) RETURN
+    lerr = checkList(isot(iis)%keys(:)%name, .NOT.[( ALLOCATED(isot(iis)%keys(is)%key), is=1, SIZE(isot(iis)%keys) )], &
+                     'Check file "'//TRIM(fnam)//'" in section "'//TRIM(dBase(idb)%name)//'"', 'isotopes', 'missing')
+    IF(lerr) RETURN
   END DO
 
@@ -1109,6 +1185,6 @@
       END DO
     END DO
-    IF(test(fmsg('Problem with the table content', modname, dispTable(prf, ttl, val, &
-            cat([(it,it=1,nt)]), rFmt='(EN8.4)', nColMax=maxTableWidth, nHead=2, sub=modname)), lerr)) RETURN
+    lerr = dispTable(prf, ttl, val, cat([(it,it=1,nt)]), rFmt='(EN8.4)', nColMax=maxTableWidth, nHead=2, sub=modname)
+    IF(fmsg('Problem with the table content', modname, lerr)) RETURN
     DEALLOCATE(ttl, val)
   END DO        
@@ -1116,5 +1192,5 @@
 !------------------------------------------------------------------------------------------------------------------------------
 
-END FUNCTION readIsotopesFile_prv
+END FUNCTION readIsotopesFile
 !==============================================================================================================================
 
